(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common/http'), require('@auth0/angular-jwt'), require('@angular/router'), require('jwt-decode'), require('rxjs'), require('@angular/material/dialog'), require('@angular/material/button'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-core-services', ['exports', '@angular/core', '@angular/common/http', '@auth0/angular-jwt', '@angular/router', 'jwt-decode', 'rxjs', '@angular/material/dialog', '@angular/material/button', 'rxjs/operators'], factory) :
    (global = global || self, factory(global['ngx-core-services'] = {}, global.ng.core, global.ng.common.http, global.angularJwt, global.ng.router, global.decode, global.rxjs, global.ng.material.dialog, global.ng.material.button, global.rxjs.operators));
}(this, (function (exports, core, http, angularJwt, router, decode, rxjs, dialog, button, operators) { 'use strict';

    decode = decode && decode.hasOwnProperty('default') ? decode['default'] : decode;

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __exportStar(m, exports) {
        for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
        if (m) return m.call(o);
        return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    var NGX_CORE_TOKEN = new core.InjectionToken('NGX_CORE_TOKEN');

    var NgxCoreComponent = /** @class */ (function () {
        function NgxCoreComponent(ngxCoreConfig) {
            this.ngxCoreConfig = ngxCoreConfig;
            this.authHost = this.ngxCoreConfig.authHost;
            this.apiHost = this.ngxCoreConfig.apiHost;
            this.project = this.ngxCoreConfig.project;
        }
        NgxCoreComponent.prototype.ngOnInit = function () {
        };
        NgxCoreComponent.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [NGX_CORE_TOKEN,] }] }
        ]; };
        NgxCoreComponent = __decorate([
            core.Component({
                selector: 'lib-ngx-core',
                template: "\n  <div style=\"background: lightsalmon\">\n      <p> ngx-core works! </p>\n      <p>{{ authHost }} </p>\n      <p>{{ apiHost }} </p>\n      <p>{{ project }} </p>\n  </div>\n    \n  \n  "
            }),
            __param(0, core.Inject(NGX_CORE_TOKEN))
        ], NgxCoreComponent);
        return NgxCoreComponent;
    }());

    var StorageService = /** @class */ (function () {
        function StorageService(ngxCoreConfig) {
            this.ngxCoreConfig = ngxCoreConfig;
        }
        // cookie
        StorageService.prototype.setCookie = function (name, val) {
            var date = new Date();
            var value = val;
            // Set it expire in 7 days (nap*ora*perc*mp*ms)
            date.setTime(date.getTime() + (7 * 24 * 60 * 60 * 1000));
            // Set it
            document.cookie = this.ngxCoreConfig.project + "-" + name + '=' + encodeURI(value) + '; expires=' + date.toUTCString() + '; path=/';
        };
        /**
         * Returns with a cookie associated with the given name
         * @param name
         */
        StorageService.prototype.getCookie = function (name) {
            var value = '; ' + document.cookie;
            var parts = decodeURI(value).split('; ' + (this.ngxCoreConfig.project + "-" + name) + '=');
            if (parts.length === 2) {
                return parts.pop().split(';').shift();
            }
        };
        /**
         * Deletes a cookie by name
         * @param name
         */
        StorageService.prototype.deleteCookie = function (name) {
            var date = new Date();
            // Set it expire in -1 days
            date.setTime(date.getTime() + (-1 * 24 * 60 * 60 * 1000));
            // Set it
            document.cookie = this.ngxCoreConfig.project + "-" + name + '=; expires=' + date.toUTCString() + '; path=/';
        };
        /**
        * Deletes all cookies
        */
        StorageService.prototype.clearCookies = function () {
            var cookies = document.cookie.split(";");
            for (var i = 0; i < cookies.length; i++) {
                var cookie = cookies[i];
                var eqPos = cookie.indexOf("=");
                var name = eqPos > -1 ? cookie.substr(0, eqPos) : cookie;
                document.cookie = name + "=;expires=Thu, 01 Jan 1970 00:00:00 GMT";
            }
        };
        // localStorage
        StorageService.prototype.setStorage = function (name, val) {
            localStorage.setItem(this.ngxCoreConfig.project + "-" + name, val);
        };
        StorageService.prototype.getStorage = function (name) {
            var item = localStorage.getItem(this.ngxCoreConfig.project + "-" + name);
            return item;
        };
        StorageService.prototype.deleteStorage = function (name) {
            localStorage.removeItem(this.ngxCoreConfig.project + "-" + name);
        };
        StorageService.prototype.clearStorage = function () {
            localStorage.clear();
        };
        StorageService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [NGX_CORE_TOKEN,] }] }
        ]; };
        StorageService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function StorageService_Factory() { return new StorageService(core["ɵɵinject"](NGX_CORE_TOKEN)); }, token: StorageService, providedIn: "root" });
        StorageService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(0, core.Inject(NGX_CORE_TOKEN))
        ], StorageService);
        return StorageService;
    }());

    var AuthService = /** @class */ (function () {
        function AuthService(ngxCoreConfig, jwtHelper, storageService, router, http) {
            this.ngxCoreConfig = ngxCoreConfig;
            this.jwtHelper = jwtHelper;
            this.storageService = storageService;
            this.router = router;
            this.http = http;
            this.subChange = new rxjs.Subject();
        }
        /**
         * User has access to the path and valid token.
         * @param route
         */
        AuthService.prototype.canActivate = function (route) {
            var expectedRole = route.data.expectedRole;
            var token = this.getToken();
            if (!token) {
                this.router.navigate(['']);
                return false;
            }
            else {
                var tokenPayload = decode(token);
                var userRole = tokenPayload.identity.role;
                if (!this.isAuthenticated() ||
                    !expectedRole.includes(userRole)) {
                    this.router.navigate(['']);
                    return false;
                }
                return true;
            }
        };
        /**
         * User has valid token.
         */
        AuthService.prototype.isAuthenticated = function () {
            var token = this.getToken();
            if (!token) {
                return false;
            }
            else {
                return !this.jwtHelper.isTokenExpired(token);
            }
        };
        /**
         * Returns user token.
         */
        AuthService.prototype.getToken = function () {
            var token = this.storageService.getCookie('access_token');
            return token;
        };
        /**
         * Get a fresh token using the refresh token
         * @param url
         * @param data
         */
        AuthService.prototype.postUserTokenRefresh = function (url, data) {
            return this.http.post(this.ngxCoreConfig.authHost + url, data);
        };
        /**
         * Get user role.
         */
        AuthService.prototype.getRole = function () {
            var token = this.getToken();
            var role = token ? decode(token).identity.role : null;
            return role;
        };
        /**
         * Get username.
         */
        AuthService.prototype.getUsername = function () {
            var token = this.getToken();
            var username = token ? decode(token).identity.username : null;
            return username;
        };
        /**
       * Get name.
       */
        AuthService.prototype.getName = function () {
            var token = this.getToken();
            var name = token ? decode(token).identity.name : null;
            return name;
        };
        /**
        * Get user data.
        */
        AuthService.prototype.getUserData = function () {
            var token = this.getToken();
            var usrData = token ? decode(token).identity : null;
            return usrData;
        };
        /**
         * Data change subject.
         * @param data
         */
        AuthService.prototype.change = function (data) {
            this.subChange.next(data);
        };
        /**
         * User login.
         * @param url
         * @param data
         */
        AuthService.prototype.login = function (url, data) {
            data['refreshType'] = this.ngxCoreConfig.refreshType;
            return this.http.post(this.ngxCoreConfig.authHost + url, data);
        };
        AuthService.prototype.allUsers = function (url, data) {
            data['refreshType'] = this.ngxCoreConfig.refreshType;
            return this.http.get(this.ngxCoreConfig.authHost + url, { params: { data: data } });
        };
        /**
         * User logout, cookie and storage clear.
         * @param url
         * @param data
         */
        AuthService.prototype.logout = function (url, data) {
            // this.storageService.clearStorage();
            // this.storageService.clearCookies();
            return this.http.post(this.ngxCoreConfig.authHost + url, data);
        };
        /**
         * User logout, cookie and storage clear.
         * @param url
         * @param data
         */
        AuthService.prototype.post = function (url, data) {
            return this.http.post(this.ngxCoreConfig.authHost + url, data);
        };
        AuthService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [NGX_CORE_TOKEN,] }] },
            { type: angularJwt.JwtHelperService },
            { type: StorageService },
            { type: router.Router },
            { type: http.HttpClient }
        ]; };
        AuthService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function AuthService_Factory() { return new AuthService(core["ɵɵinject"](NGX_CORE_TOKEN), core["ɵɵinject"](angularJwt.JwtHelperService), core["ɵɵinject"](StorageService), core["ɵɵinject"](router.Router), core["ɵɵinject"](http.HttpClient)); }, token: AuthService, providedIn: "root" });
        AuthService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(0, core.Inject(NGX_CORE_TOKEN))
        ], AuthService);
        return AuthService;
    }());

    var PermissionDirective = /** @class */ (function () {
        function PermissionDirective(authService) {
            this.authService = authService;
            this.userRole = this.authService.getRole();
            if (this.hasPermission === undefined) {
                this.hasPermission = true;
            }
            if (this.arrPermission && this.userRole !== null) {
                this.setVisibilityByArrPerm();
            }
        }
        PermissionDirective.prototype.setVisibilityByArrPerm = function () {
            if (!this.arrPermission) {
                this.er.nativeElement.style.display = 'block';
            }
            else {
                if (this.hasPermission === true) {
                    if (this.arrPermission.includes(this.userRole)) {
                        this.er.nativeElement.style.display = 'block';
                    }
                    else {
                        this.er.nativeElement.style.display = 'none';
                    }
                }
                else {
                    if (this.arrPermission.includes(this.userRole)) {
                        this.er.nativeElement.style.display = 'none';
                    }
                    else {
                        this.er.nativeElement.style.display = 'block';
                    }
                }
            }
        };
        PermissionDirective.ctorParameters = function () { return [
            { type: AuthService }
        ]; };
        __decorate([
            core.Input('libPermission')
        ], PermissionDirective.prototype, "arrPermission", void 0);
        __decorate([
            core.Input('hasPermission')
        ], PermissionDirective.prototype, "hasPermission", void 0);
        PermissionDirective = __decorate([
            core.Directive({
                selector: '[libPermission]'
            })
        ], PermissionDirective);
        return PermissionDirective;
    }());

    var ConfirmDialogComponent = /** @class */ (function () {
        function ConfirmDialogComponent(message, dialogRef) {
            this.message = message;
            this.dialogRef = dialogRef;
        }
        ConfirmDialogComponent.prototype.ngOnInit = function () {
        };
        ConfirmDialogComponent.ctorParameters = function () { return [
            { type: String, decorators: [{ type: core.Inject, args: [dialog.MAT_DIALOG_DATA,] }] },
            { type: dialog.MatDialogRef }
        ]; };
        ConfirmDialogComponent = __decorate([
            core.Component({
                selector: 'lib-confirm-dialog',
                template: "<div mat-dialog-content>\r\n    {{ message }}\r\n  </div>\r\n  <div mat-dialog-actions>\r\n    <button mat-button [mat-dialog-close]=\"false\">Nem</button>\r\n    <button mat-button [mat-dialog-close]=\"true\" cdkFocusInitial>Igen</button>\r\n  </div>\r\n  ",
                styles: [""]
            }),
            __param(0, core.Inject(dialog.MAT_DIALOG_DATA))
        ], ConfirmDialogComponent);
        return ConfirmDialogComponent;
    }());

    var NgxCoreModule = /** @class */ (function () {
        function NgxCoreModule() {
        }
        NgxCoreModule_1 = NgxCoreModule;
        NgxCoreModule.forRoot = function (ngxCoreConfig) {
            return {
                ngModule: NgxCoreModule_1,
                providers: [
                    {
                        provide: NGX_CORE_TOKEN,
                        useValue: ngxCoreConfig
                    }
                ]
            };
        };
        var NgxCoreModule_1;
        NgxCoreModule = NgxCoreModule_1 = __decorate([
            core.NgModule({
                declarations: [NgxCoreComponent, PermissionDirective, ConfirmDialogComponent],
                imports: [
                    button.MatButtonModule,
                    dialog.MatDialogModule,
                    http.HttpClientModule,
                    angularJwt.JwtModule.forRoot({
                        config: {
                            tokenGetter: null,
                            whitelistedDomains: [],
                            blacklistedRoutes: []
                        }
                    }),
                ],
                exports: [NgxCoreComponent],
            })
        ], NgxCoreModule);
        return NgxCoreModule;
    }());

    var ApiService = /** @class */ (function () {
        function ApiService(ngxCoreConfig, http) {
            this.ngxCoreConfig = ngxCoreConfig;
            this.http = http;
        }
        /**
         * Http GET request.
         * @param url
         * @param data
         */
        ApiService.prototype.get = function (url, data) {
            return this.http.get(this.ngxCoreConfig.apiHost + url, {
                params: data
            });
        };
        /**
         * Http PUT request.
         * @param url
         * @param data
         */
        ApiService.prototype.put = function (url, data) {
            return this.http.put(this.ngxCoreConfig.apiHost + url, data);
        };
        /**
         * Http POST request.
         * @param url
         * @param data
         */
        ApiService.prototype.post = function (url, data) {
            return this.http.post(this.ngxCoreConfig.apiHost + url, data);
        };
        /**
         * Http DELETE request.
         * @param url
         * @param data
         */
        ApiService.prototype.delete = function (url, data) {
            return this.http.delete(this.ngxCoreConfig.apiHost + url, {
                params: data
            });
        };
        ApiService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [NGX_CORE_TOKEN,] }] },
            { type: http.HttpClient }
        ]; };
        ApiService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function ApiService_Factory() { return new ApiService(core["ɵɵinject"](NGX_CORE_TOKEN), core["ɵɵinject"](http.HttpClient)); }, token: ApiService, providedIn: "root" });
        ApiService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(0, core.Inject(NGX_CORE_TOKEN))
        ], ApiService);
        return ApiService;
    }());

    var ErrorInterceptorService = /** @class */ (function () {
        function ErrorInterceptorService(
        //private snackBarService: SnackbarService,
        storageService, // -> authService
        router) {
            this.storageService = storageService;
            this.router = router;
        }
        ErrorInterceptorService.prototype.intercept = function (request, next) {
            if (request.url.endsWith('login')) {
                return next.handle(request).pipe(operators.catchError(function (err) {
                    var error = err.error.message || err.statusText;
                    return rxjs.throwError(error);
                }));
            }
            else {
                if (this.storageService.getCookie('access_token') !== undefined) {
                    return next.handle(request).pipe(operators.catchError(function (err) {
                        var error = err.error.message || err.statusText;
                        return rxjs.throwError(error);
                    }));
                }
                else {
                    this.router.navigate(['']);
                    this.storageService.clearCookies();
                    return next.handle(request).pipe(operators.catchError(function (err) {
                        var error = err.error.message || err.statusText;
                        return rxjs.throwError(error);
                    }));
                }
            }
        };
        ErrorInterceptorService.ctorParameters = function () { return [
            { type: StorageService },
            { type: router.Router }
        ]; };
        ErrorInterceptorService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function ErrorInterceptorService_Factory() { return new ErrorInterceptorService(core["ɵɵinject"](StorageService), core["ɵɵinject"](router.Router)); }, token: ErrorInterceptorService, providedIn: "root" });
        ErrorInterceptorService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], ErrorInterceptorService);
        return ErrorInterceptorService;
    }());

    var JwtInterceptorService = /** @class */ (function () {
        function JwtInterceptorService(storageService, ngxCoreConfig, jwtHelper) {
            this.storageService = storageService;
            this.ngxCoreConfig = ngxCoreConfig;
            this.jwtHelper = jwtHelper;
        }
        JwtInterceptorService.prototype.intercept = function (request, next) {
            var token = this.storageService.getCookie('access_token');
            if (token) {
                if (token && !request.url.endsWith('token_refresh')) {
                    request = request.clone({
                        setHeaders: {
                            Authorization: "Bearer " + token,
                            'Client': this.ngxCoreConfig.project
                            // 'Content-Type': 'application/json'
                        }
                    });
                }
                else if (this.jwtHelper.isTokenExpired(token) && request.url.endsWith('token_refresh')) {
                    var refreshToken = this.storageService.getCookie('refresh_token');
                    request = request.clone({
                        setHeaders: {
                            Authorization: "Bearer " + refreshToken,
                            'Client': this.ngxCoreConfig.project
                            // 'Content-Type': 'application/json'
                        }
                    });
                }
            }
            else {
                request = request.clone({
                    setHeaders: {
                        'Client': this.ngxCoreConfig.project
                        // 'Content-Type': 'application/json'
                    }
                });
            }
            return next.handle(request);
        };
        JwtInterceptorService.ctorParameters = function () { return [
            { type: StorageService },
            { type: undefined, decorators: [{ type: core.Inject, args: [NGX_CORE_TOKEN,] }] },
            { type: angularJwt.JwtHelperService }
        ]; };
        JwtInterceptorService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function JwtInterceptorService_Factory() { return new JwtInterceptorService(core["ɵɵinject"](StorageService), core["ɵɵinject"](NGX_CORE_TOKEN), core["ɵɵinject"](angularJwt.JwtHelperService)); }, token: JwtInterceptorService, providedIn: "root" });
        JwtInterceptorService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(1, core.Inject(NGX_CORE_TOKEN))
        ], JwtInterceptorService);
        return JwtInterceptorService;
    }());

    var RefreshTokenInterceptor = /** @class */ (function () {
        function RefreshTokenInterceptor(auth, storageService, router, jwtHelper, ngxCoreConfig) {
            this.auth = auth;
            this.storageService = storageService;
            this.router = router;
            this.jwtHelper = jwtHelper;
            this.ngxCoreConfig = ngxCoreConfig;
            this.refreshTokenInProgress = false;
            this.refreshTokenSubject = new rxjs.BehaviorSubject(null);
        }
        RefreshTokenInterceptor.prototype.intercept = function (request, next) {
            var _this = this;
            return next.handle(request).pipe(operators.catchError(function (error) {
                // We don't want to refresh token for some requests like login or refresh token itself
                // So we verify url and we throw an error if it's the case
                if (request.url.includes('token_refresh') ||
                    request.url.includes('login')) {
                    // We do another check to see if refresh token failed
                    // In this case we want to logout user and to redirect it to login page
                    if (request.url.includes('token_refresh')) {
                        _this.auth.post('/users/logout_access', {});
                    }
                    return rxjs.throwError(error);
                }
                // If error status is different than 401 we want to skip refresh token
                // So we check that and throw the error if it's the case
                if (error.status !== 401) {
                    return rxjs.throwError(error);
                }
                if (_this.refreshTokenInProgress) {
                    // If refreshTokenInProgress is true, we will wait until refreshTokenSubject has a non-null value
                    // – which means the new token is ready and we can retry the request again
                    return _this.refreshTokenSubject.pipe(operators.delayWhen(function (val) { return val ? rxjs.interval(500) : rxjs.of(!_this.jwtHelper.isTokenExpired(_this.auth.getToken())); }), operators.filter(function (token) { return token != null; }), operators.take(1), operators.concatMap(function (token) {
                        return next.handle(_this.addAuthenticationToken(request));
                    }));
                }
                else {
                    if (_this.ngxCoreConfig.refreshType === 0) {
                        _this.refreshTokenInProgress = true;
                        // Set the refreshTokenSubject to null so that subsequent API calls will wait until the new token has been retrieved
                        _this.refreshTokenSubject.next(null);
                        // Call auth.refreshAccessToken(this is an Observable that will be returned)
                        return _this.auth.postUserTokenRefresh('/users/token_refresh', {}).pipe(operators.switchMap(function (token) {
                            // When the call to refreshToken completes we reset the refreshTokenInProgress to false
                            // for the next time the token needs to be refreshed
                            _this.refreshTokenInProgress = false;
                            _this.refreshTokenSubject.next(token['access_token']);
                            _this.storageService.setCookie('access_token', token['access_token']);
                            return next.handle(_this.addAuthenticationToken(request));
                        }), operators.catchError(function (err) {
                            _this.refreshTokenInProgress = false;
                            _this.auth.post('/users/logout_access', {});
                            return rxjs.throwError(err);
                        }));
                        /* } else if (this.ngxCoreConfig.refreshType === '1') {
                          this.refreshTokenInProgress = true;
              
                          // Set the refreshTokenSubject to null so that subsequent API calls will wait until the new token has been retrieved
                          this.refreshTokenSubject.next(null);
              
                          let dialogResult = false;
              
                          const msg = 'Időtúllépés. Szeretne bejelentkezve maradni?';
                          const dlg = this.dialog.open(ConfirmDialogComponent, {
                            data: msg
                          });
              
                          dlg.afterClosed().subscribe(result => {
                            dialogResult = result;
                          });
              
                          setTimeout(() => {
                            dialogResult = true;
                          }, 2900);
              
                          return this.auth.postUserTokenRefresh('users/token_refresh', {}).pipe(
                            delayWhen(val => val ? interval(3000) : of(!dialogResult)),
                            switchMap((token: any) => {
                              // When the call to refreshToken completes we reset the refreshTokenInProgress to false
                              // for the next time the token needs to be refreshed
                              this.refreshTokenInProgress = false;
                              this.refreshTokenSubject.next(token['access_token']);
                              this.storageService.setCookie('access_token', token['access_token']);
                              return next.handle(this.addAuthenticationToken(request));
                            }),
                            catchError((err: any) => {
                              this.refreshTokenInProgress = false;
                              this.router.navigate(['']);
                              dlg.close();
                              this.storageService.clearCookies();
                              this.storageService.clearStorage();
                              this.auth.post('users/logout_access', {});
                              return throwError(err);
                            })); */
                    }
                    else {
                        _this.router.navigate(['']);
                        _this.storageService.clearCookies();
                        _this.storageService.clearStorage();
                    }
                }
            }));
        };
        RefreshTokenInterceptor.prototype.addAuthenticationToken = function (request) {
            // Get access token from Local Storage
            var accessToken = this.auth.getToken();
            // If access token is null this means that user is not logged in
            // And we return the original request
            if (!accessToken) {
                return request;
            }
            // We clone the request, because the original request is immutable
            return request.clone({
                setHeaders: {
                    Authorization: 'Bearer ' + this.auth.getToken()
                }
            });
        };
        RefreshTokenInterceptor.ctorParameters = function () { return [
            { type: AuthService },
            { type: StorageService },
            { type: router.Router },
            { type: angularJwt.JwtHelperService },
            { type: undefined, decorators: [{ type: core.Inject, args: [NGX_CORE_TOKEN,] }] }
        ]; };
        RefreshTokenInterceptor = __decorate([
            core.Injectable(),
            __param(4, core.Inject(NGX_CORE_TOKEN))
        ], RefreshTokenInterceptor);
        return RefreshTokenInterceptor;
    }());

    var AppStateService = /** @class */ (function () {
        function AppStateService(ngxCoreConfig) {
            this.ngxCoreConfig = ngxCoreConfig;
            this.asObj = new Object();
            this.datachange = new rxjs.BehaviorSubject(null);
        }
        /**
        * Sets the viewState object. Loads the project name and loggedIn = false if first init,
        * else loads it from the localStorage.
        */
        AppStateService.prototype.setAppState = function () {
            if (!localStorage.getItem(this.ngxCoreConfig.project + "-app-state")) {
                this.asObj['name'] = this.ngxCoreConfig.project;
                this.asObj['loggedIn'] = false;
                var objToJson = JSON.stringify(this.asObj);
                console.log(objToJson);
                console.log(this.asObj);
                localStorage.setItem(this.ngxCoreConfig.project + "-app-state", objToJson);
                this.datachange.next(this.asObj);
            }
            else {
                this.asObj = localStorage.getItem(this.ngxCoreConfig.project + "-app-state")
                    ? JSON.parse(localStorage.getItem(this.ngxCoreConfig.project + "-app-state"))
                    : this.asObj;
                console.log(localStorage.getItem(this.ngxCoreConfig.project + "-app-state"));
                this.datachange.next(this.asObj);
            }
        };
        /**
        * Returns the appState object.
        */
        AppStateService.prototype.getAppState = function () {
            this.asObj = localStorage.getItem(this.ngxCoreConfig.project + "-app-state")
                ? JSON.parse(localStorage.getItem(this.ngxCoreConfig.project + "-app-state"))
                : this.asObj;
            return this.asObj;
        };
        /**
         * Returns the value of the given key from the asObj.
         */
        AppStateService.prototype.getAppStateByKey = function (key) {
            this.asObj = localStorage.getItem(this.ngxCoreConfig.project + "-app-state")
                ? JSON.parse(localStorage.getItem(this.ngxCoreConfig.project + "-app-state"))
                : this.asObj;
            return this.asObj[key];
        };
        /**
         * Changes the provided key-value pair in the asObj.
         * @param obj
         */
        AppStateService.prototype.changeAppState = function (obj) {
            this.asObj = localStorage.getItem(this.ngxCoreConfig.project + "-app-state")
                ? JSON.parse(localStorage.getItem(this.ngxCoreConfig.project + "-app-state"))
                : this.asObj;
            for (var key in obj) {
                if (obj.hasOwnProperty(key)) {
                    var element = obj[key];
                    this.asObj[key] = element;
                }
            }
            var objToJson = JSON.stringify(this.asObj);
            localStorage.setItem(this.ngxCoreConfig.project + "-app-state", objToJson);
            this.datachange.next(obj);
        };
        AppStateService.ctorParameters = function () { return [
            { type: undefined, decorators: [{ type: core.Inject, args: [NGX_CORE_TOKEN,] }] }
        ]; };
        AppStateService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function AppStateService_Factory() { return new AppStateService(core["ɵɵinject"](NGX_CORE_TOKEN)); }, token: AppStateService, providedIn: "root" });
        AppStateService = __decorate([
            core.Injectable({
                providedIn: 'root'
            }),
            __param(0, core.Inject(NGX_CORE_TOKEN))
        ], AppStateService);
        return AppStateService;
    }());

    var ViewStateService = /** @class */ (function () {
        //datachange: Subject<any> = new Subject<any>();
        function ViewStateService() {
            //mapObj = new Map();
            this.vsObj = new Object();
            this.dataChange = new rxjs.Subject();
        }
        /**
         * Returns the viewState object. (Map<String, any>)
         */
        ViewStateService.prototype.getViewState = function () {
            //const vs = JSON.parse(JSON.stringify([...this.mapObj]));
            var vs = JSON.parse(JSON.stringify(this.vsObj));
            return vs;
        };
        /**
         * Sets the viewState - only use it in the view constructor!
         */
        ViewStateService.prototype.setViewState = function (obj) {
            /*
            this.mapObj.set('view', obj.view);
            this.mapObj.set('history', []);
            this.datachange.next(obj);*/
            this.vsObj['view'] = obj.view;
            this.vsObj['history'] = [];
            this.dataChange.next(this.vsObj);
        };
        /**
         * Returns data that maches the given parameter.
         * @param key Data name.
         */
        ViewStateService.prototype.getViewStateByKey = function (key) {
            //return this.mapObj.get(key);
            return this.vsObj["" + key];
        };
        /**
         * Returns the current view.
         */
        ViewStateService.prototype.getView = function () {
            // return this.mapObj.get('view');
            return this.vsObj['view'];
        };
        /**
         * Changes the view state. Sets the goven data and history, emits the current change.
         * @param obj Current change.
         * @param history History - name of the event.
         */
        ViewStateService.prototype.changeViewState = function (obj, history) {
            /*history = history ? history : `${this.mapObj.get('view')}Event`;
            for (const key in obj) {
              if (obj.hasOwnProperty(key)) {
                const element = obj[key];
                this.mapObj.set(`${key}`, element);
                this.mapObj.get('history').push({event: history, value: element});
              }
            }
            this.datachange.next(obj);*/
            history = history ? history : this.vsObj['view'] + "Event";
            for (var key in obj) {
                if (obj.hasOwnProperty(key)) {
                    var element = obj[key];
                    this.vsObj["" + key] = element;
                    this.vsObj['history'].push({ event: history, value: element });
                }
            }
            obj.view = this.vsObj.view;
            this.dataChange.next(obj);
        };
        ViewStateService.ɵprov = core["ɵɵdefineInjectable"]({ factory: function ViewStateService_Factory() { return new ViewStateService(); }, token: ViewStateService, providedIn: "root" });
        ViewStateService = __decorate([
            core.Injectable({
                providedIn: 'root'
            })
        ], ViewStateService);
        return ViewStateService;
    }());

    exports.ApiService = ApiService;
    exports.AppStateService = AppStateService;
    exports.AuthService = AuthService;
    exports.ErrorInterceptorService = ErrorInterceptorService;
    exports.JwtInterceptorService = JwtInterceptorService;
    exports.NgxCoreModule = NgxCoreModule;
    exports.PermissionDirective = PermissionDirective;
    exports.RefreshTokenInterceptor = RefreshTokenInterceptor;
    exports.StorageService = StorageService;
    exports.ViewStateService = ViewStateService;
    exports.ɵa = NgxCoreComponent;
    exports.ɵb = NGX_CORE_TOKEN;
    exports.ɵc = ConfirmDialogComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-core-services.umd.js.map
