import { NgxCoreConfig } from '../../../public-api';
import { HttpClient } from '@angular/common/http';
export declare class ApiService {
    private ngxCoreConfig;
    private http;
    constructor(ngxCoreConfig: NgxCoreConfig, http: HttpClient);
    /**
     * Http GET request.
     * @param url
     * @param data
     */
    get(url: string, data?: any): import("rxjs").Observable<Object>;
    /**
     * Http PUT request.
     * @param url
     * @param data
     */
    put(url: string, data?: any): import("rxjs").Observable<Object>;
    /**
     * Http POST request.
     * @param url
     * @param data
     */
    post(url: string, data?: any): import("rxjs").Observable<Object>;
    /**
     * Http DELETE request.
     * @param url
     * @param data
     */
    delete(url: string, data?: any): import("rxjs").Observable<Object>;
}
