import { StorageService } from '../storage/storage.service';
import { HttpRequest, HttpHandler, HttpEvent, HttpInterceptor } from '@angular/common/http';
import { Observable } from 'rxjs';
import { NgxCoreConfig } from '../../ngx-core-config';
import { JwtHelperService } from '@auth0/angular-jwt';
export declare class JwtInterceptorService implements HttpInterceptor {
    private storageService;
    private ngxCoreConfig;
    private jwtHelper;
    constructor(storageService: StorageService, ngxCoreConfig: NgxCoreConfig, jwtHelper: JwtHelperService);
    intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
}
