import { HttpEvent, HttpHandler, HttpInterceptor, HttpRequest } from '@angular/common/http';
import { Router } from '@angular/router';
import { JwtHelperService } from '@auth0/angular-jwt';
import { Observable } from 'rxjs';
import { NgxCoreConfig } from '../../ngx-core-config';
import { AuthService } from '../auth/auth.service';
import { StorageService } from '../storage/storage.service';
export declare class RefreshTokenInterceptor implements HttpInterceptor {
    auth: AuthService;
    private storageService;
    private router;
    private jwtHelper;
    private ngxCoreConfig;
    private refreshTokenInProgress;
    private refreshTokenSubject;
    constructor(auth: AuthService, storageService: StorageService, router: Router, jwtHelper: JwtHelperService, ngxCoreConfig: NgxCoreConfig);
    intercept(request: HttpRequest<any>, next: HttpHandler): Observable<HttpEvent<any>>;
    addAuthenticationToken(request: any): any;
}
