import { NgxCoreConfig } from '../../ngx-core-config';
export declare class StorageService {
    private ngxCoreConfig;
    constructor(ngxCoreConfig: NgxCoreConfig);
    setCookie(name: string, val: string): void;
    /**
     * Returns with a cookie associated with the given name
     * @param name
     */
    getCookie(name: string): string;
    /**
     * Deletes a cookie by name
     * @param name
     */
    deleteCookie(name: string): void;
    /**
    * Deletes all cookies
    */
    clearCookies(): void;
    setStorage(name: string, val: string): void;
    getStorage(name: string): string;
    deleteStorage(name: string): void;
    clearStorage(): void;
}
